package symantec.itools.awt;

import java.beans.*;
import symantec.itools.beans.*;

/**
 * BeanInfo for BaseTabbedPanel.
 *
 */

public class BaseTabbedPanelBeanInfo extends SimpleBeanInfo {

	/**
	 * Constructs a BaseTabbedPanelBeanInfo object.
	 */
	public BaseTabbedPanelBeanInfo() {
	}

	/**
	 * Gets a BeanInfo for the superclass of this bean.
	 * @return BeanInfo[] containing this bean's superclass BeanInfo
	 */
	public BeanInfo[] getAdditionalBeanInfo() {
		try {
            BeanInfo[] bi = new BeanInfo[1];
            bi[0] = Introspector.getBeanInfo(beanClass.getSuperclass());
            return bi;
		}
		catch (IntrospectionException e) { throw new Error(e.toString());}
	}

	/**
	 * Gets the SymantecBeanDescriptor for this bean.
	 * @return an object of type SymantecBeanDescriptor
	 * @see symantec.itools.beans.SymantecBeanDescriptor
	 */
	public BeanDescriptor getBeanDescriptor() {
		SymantecBeanDescriptor bd = new SymantecBeanDescriptor(beanClass);

		return (BeanDescriptor) bd;
	}

	public MethodDescriptor[] getMethodDescriptors() { return new MethodDescriptor[0]; }

	public PropertyDescriptor[] getPropertyDescriptors() { return new PropertyDescriptor[0]; }

	private final static Class beanClass = BaseTabbedPanel.class;

	}	//  end of class BaseTabbedPanelBeanInfo