package symantec.itools.awt.multiList;

import java.awt.Graphics;

/**
 * This is a helper class to the MultiList class.
 * All MultiList cells are based on this class.
 * @version 1.1, July 14, 1997
 * @author Symantec
 */
public abstract class Cell
{
	/**
	 * Constructs a Cell object.
	 */
	public Cell() {
	}
	/**
	 * Draws the cell using the given graphics context.
	 * @param g the graphics context used for drawing
	 * @param align the column alignment, one of LEFT, CENTER, or RIGHT
	 * @param x the horizontal cell position, in pixels
	 * @param y the vertical cell position, in pixels
	 * @param w the width of the cell, in pixels
	 * @param h the height of the cell, in pixels
	 * @param asc the ascent metric of the cell's font
	 * @see symantec.itools.awt.MultiList#LEFT
	 * @see symantec.itools.awt.MultiList#CENTER
	 * @see symantec.itools.awt.MultiList#RIGHT
	 */
	public abstract void drawCell(Graphics g, int align, int x, int y, int w, int h, int asc);
}
