/*
 * DebugWizardController.java
 */

package symantec.itools.awt;

import java.awt.Component;

public class DebugWizardController extends SimpleWizardController
{
    public DebugWizardController(WizardInterface wizard)
    {
        super(wizard);
    }

    public void doPrepare()
    {
        debug("doPrepare");
        super.doPrepare();
    }

    public void preparePage(Component comp, int action)
    {
        debug("preparePage:" + action);
        super.preparePage(comp, action);
    }

    public void pageShown(Component comp)
    {
        debug("pageShown");
        super.pageShown(comp);
    }

    public boolean validatePage(Component comp, Component target, int action)
    {
        debug("validatePage:" + action);
        return super.validatePage(comp, target, action);
    }

    public void pageHidden(Component comp)
    {
        debug("pageHidden");
        super.pageHidden(comp);
    }

    public void doFinish()
    {
        debug("doFinish");
        super.doFinish();
    }

    public void doCancel()
    {
        debug("doCancel");
        super.doCancel();
    }

    public void doHelp()
    {
        debug("doHelp");
        super.doHelp();
    }

    public boolean isPreviousEnabled()
    {
        debug("isPreviousEnabled");
        return super.isPreviousEnabled();
    }

    public boolean isNextEnabled()
    {
        debug("isNextEnabled");
        return super.isNextEnabled();
    }

    public boolean isFinishEnabled()
    {
        debug("isFinishEnabled");
        return super.isFinishEnabled();
    }

    public boolean isCancelEnabled()
    {
        debug("isCancelEnabled");
        return super.isCancelEnabled();
    }

    public boolean isHelpEnabled()
    {
        debug("isHelpEnabled");
        return super.isHelpEnabled();
    }

    public Component getPreviousPage()
    {
        debug("getPreviousPage");
        return super.getPreviousPage();
    }

    public Component getNextPage()
    {
        debug("getNextPage");
        return super.getNextPage();
    }

    public void setPreviousPageIndex(int index)
    {
        debug("setPreviousPageIndex: " + index);
        super.setPreviousPageIndex(index);
    }

    public void setNextPageIndex(int index)
    {
        debug("setNextPageIndex: " + index);
        super.setNextPageIndex(index);
    }

    public void setPreviousPage(Component comp)
    {
        debug("setPreviousPage");
        super.setPreviousPage(comp);
    }

    public void setNextPage(Component comp)
    {
        debug("setNextPage");
        super.setNextPage(comp);
    }
    
    public void setPreviousEnabled(boolean status)
    {
        debug("setPreviousEnabled");
        super.setPreviousEnabled(status);
    }
    
    public void setNextEnabled(boolean status)
    {
        debug("setNextEnabled");
        super.setNextEnabled(status);
    }
    
    public void setFinishEnabled(boolean status)
    {
        debug("setFinishEnabled");
        super.setFinishEnabled(status);
    }
    
    public void setCancelEnabled(boolean status)
    {
        debug("setCancelEnabled");
        super.setCancelEnabled(status);
    }
    
    public void setHelpEnabled(boolean status)
    {
        debug("setHelpEnabled");
        super.setHelpEnabled(status);
    }

    public void resetChainInfo()
    {
        debug("resetChainInfo");
        super.resetChainInfo();
    }

    private void debug(String s)
    {
        System.err.println("DebugWizardController:: " + s);
    }
}
