package symantec.itools.demo;


import java.awt.Event;
import java.awt.Frame;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;


/**
 *
 *
 *
 * @see
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


class DemoFrame
    extends Frame
{
    Demo demo;

    public DemoFrame(Demo d)
    {
        this(d, "Demo");
    }

    public DemoFrame(Demo d, String s)
    {
        super(s);

        MenuBar menubar;
        Menu    menu;

        demo = d;

        menubar = new MenuBar();

        menu = new Menu("File");
        menu.add(new MenuItem("Restart"));
        menu.add(new MenuItem("Exit"));
        menubar.add(menu);

        menu = new Menu("Help");
        menu.add(new MenuItem("Help"));
        menu.addSeparator();
        menu.add(new MenuItem("About " + demo.getClass().getName() + "..."));
        menubar.add(menu);

        setMenuBar(menubar);
    }

    public boolean handleEvent(Event e)
    {
        switch(e.id)
        {
        	case Event.WINDOW_DESTROY :
        	{
        	    demo.doExit();

	            return (true);
        	}

        	case Event.ACTION_EVENT :
        	{
        	    if(e.target instanceof MenuItem)
        	    {
        	        String label;

        	        label = (String)e.arg;

        	        if(label.equals("Restart"))
        	        {
        	            demo.doRestart();

        	            return (true);
        	        }
        	        else if(label.equals("Exit"))
        	        {
        	            demo.doExit();

        	            return (true);
        	        }
        	        else if(label.equals("Help"))
        	        {
        	            demo.doHelp();

        	            return (true);
        	        }
        	        else if(label.startsWith("About") && label.endsWith("..."))
        	        {
        	            demo.doAbout();

        	            return (true);
        	        }
        	    }
        	}
        }

        return (demo.handleEvent(e));
    }
}