package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field for an international phone number.
 * IntlLongDistPhoneNumber limits the type of text that can be entered in the text
 * box to an international long distance phone number (thirteen-digit number).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @author	Symantec
 *
 */


public class IntlLongDistPhoneNumber
    extends LongDistPhoneNumber
{
    /**
     * Create international long distance phone number text field.
     * This is a formatted text field
     * with the following format: /0/1/1/ 99/ 999/ 999/-9999
     */
    public IntlLongDistPhoneNumber()
    {
        super(14);

        super.setMask("/0/1/1/ 99/ 999/ 999/-9999");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the phone number mask.
     */
    public void setMask(String s)
    {
    }
}
