package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field in which your user can type in a phone number.
 * LocalPhoneNumber limits the type of text that can be entered in the text
 * box to a local U.S. phone number (seven-digit number).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


public class LocalPhoneNumber
    extends PhoneNumber
{
    /**
     * Create local phone number text field.  This is a formatted text field
     * with the following format: 999/-9999
     */
    public LocalPhoneNumber()
    {
        super(8);

        super.setMask("999/-9999");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the local phone number mask.
     */
    public void setMask(String s)
    {
    }
}
