package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field for a Zip plus 4 code.
 * LongZipCode limits the type of text that can be entered in the text
 * box to a U.S. nine digit Zip Code (nine-digit number).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


public class LongZipCode
    extends AddressCode
{
     /**
     * Create nine digit Zip code text field.
     * This is a formatted text field
     * with the following format: 99999/-9999
     */
    public LongZipCode()
    {
        super(5);

        super.setMask("99999/-9999");
    }
    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the long zip code mask.
     */
    public void setMask(String s)
    {
    }

}
