package symantec.itools.awt.util.dialog;

import java.awt.Frame;

/**
 * Specifies a modal dialog.
 * This dialog is not resizable and will close itself as needed.
 */
public class ModalDialog extends DialogBox {

    /**
     * Constructs a ModalDialog with the given parent.
     * @param f the frame of this dialogs parent
     */
    public ModalDialog(Frame f) {
        super(f, true);
    }

    /**
     * Constructs a ModalDialog with the given parent and title.
     * @param f the frame of this dialogs parent
     * @param s the title for this dialog
     */
    public ModalDialog(Frame f, String s) {
        super(f, s, true);
    }

}
