package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field for a postal code.
 * PostalCode limits the type of text that can be entered in the text
 * box to a postal code (a mix of 6 letters and numbers).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


public class PostalCode
    extends AddressCode
{
     /**
     * Create postal code text field.
     * This is a formatted text field
     * with the following format: U9U/-9U9
     */

    public PostalCode()
    {
        super(7);

        super.setMask("U9U/-9U9");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the postal code mask.
     */
    public void setMask(String s)
    {
    }
}