package symantec.itools.awt;

import java.beans.*;
import symantec.itools.beans.*;
import java.util.ResourceBundle;

//  09/11/97	LAB	Added selectedRadioButtonIndex property and connections.
//  09/13/97	LAB	Removed extranious getPropertyDescriptors method and
//					removed extranious getMethodDescriptors method.

/**
 * BeanInfo for RadioButtonGroupPanel.
 *
 */
public class RadioButtonGroupPanelBeanInfo extends SimpleBeanInfo {

	/**
	 * Constructs a RadioButtonGroupPanelBeanInfo object.
	 */
	public RadioButtonGroupPanelBeanInfo() {
	}

	/**
	 * Gets a BeanInfo for the superclass of this bean.
	 * @return BeanInfo[] containing this bean's superclass BeanInfo
	 */
	public BeanInfo[] getAdditionalBeanInfo() {
		try {
            BeanInfo[] bi = new BeanInfo[1];
            bi[0] = Introspector.getBeanInfo(beanClass.getSuperclass());
            return bi;
		}
		catch (IntrospectionException e) { throw new Error(e.toString());}
	}

	/**
	 * Gets the SymantecBeanDescriptor for this bean.
	 * @return an object of type SymantecBeanDescriptor
	 * @see symantec.itools.beans.SymantecBeanDescriptor
	 */
	public BeanDescriptor getBeanDescriptor() {
        ResourceBundle group = ResourceBundle.getBundle("symantec.itools.resources.GroupBundle");
		String s=group.getString("GroupPanel"); 

		SymantecBeanDescriptor bd = new SymantecBeanDescriptor(beanClass);
		bd.setFolder(s);
		bd.setToolbar(s);
        bd.setWinHelp("0x123B8");

		return (BeanDescriptor) bd;
	}

	/**
	 * Gets an image that may be used to visually represent this bean
	 * (in the toolbar, on a form, etc).
	 * @param iconKind the type of icon desired, one of: BeanInfo.ICON_MONO_16x16,
	 * BeanInfo.ICON_COLOR_16x16, BeanInfo.ICON_MONO_32x32, or BeanInfo.ICON_COLOR_32x32.
	 * @return an image for this bean, always color even if requested monochrome
	 * @see BeanInfo#ICON_MONO_16x16
	 * @see BeanInfo#ICON_COLOR_16x16
	 * @see BeanInfo#ICON_MONO_32x32
	 * @see BeanInfo#ICON_COLOR_32x32
	 */
	public java.awt.Image getIcon(int iconKind) {
		if (iconKind == BeanInfo.ICON_MONO_16x16 ||
			iconKind == BeanInfo.ICON_COLOR_16x16) {
			java.awt.Image img = loadImage("RadioButtonGroupPanelC16.gif");
			return img;
		}

		if (iconKind == BeanInfo.ICON_MONO_32x32 ||
			iconKind == BeanInfo.ICON_COLOR_32x32) {
			java.awt.Image img = loadImage("RadioButtonGroupPanelC32.gif");
			return img;
		}

		return null;
	}

	/**
	 * Gets an array of descriptions of the methods used for "connections" by
	 * Visual Caf's Interaction Wizard.
	 * Included in each method description is a CONNECTIONS ConnectionDescriptor.
	 * @return method descriptions for this bean
	 * @see symantec.itools.beans.ConnectionDescriptor#CONNECTIONS
	 */
	public MethodDescriptor[] getMethodDescriptors() {
		Class[] args;
		ConnectionDescriptor connection;
		java.util.Vector connections;
		java.util.Vector md = new java.util.Vector();
		ResourceBundle conn = ResourceBundle.getBundle("symantec.itools.resources.ConnBundle");

		try{
			args = new Class[1];
			args[0] = java.lang.Integer.TYPE ;
			MethodDescriptor setSelectedRadioButtonIndex = new MethodDescriptor(beanClass.getMethod("setSelectedRadioButtonIndex", args));

			connections = new java.util.Vector();
			connection = new ConnectionDescriptor("input", "int", "",
									"%name%.setSelectedRadioButtonIndex(%arg%);",
									conn.getString("setSelectedRadioButtonIndex"));
			connections.addElement(connection);

			setSelectedRadioButtonIndex.setValue(ConnectionDescriptor.CONNECTIONS, connections);
			md.addElement(setSelectedRadioButtonIndex);
		} catch (Exception e) { throw new Error("setSelectedRadioButtonIndex:: " + e.toString()); }


		try{
			args = null;
			MethodDescriptor getSelectedRadioButtonIndex = new MethodDescriptor(beanClass.getMethod("getSelectedRadioButtonIndex", args));

			connections = new java.util.Vector();
			connection = new ConnectionDescriptor("output", "int", "",
									"%name%.getSelectedRadioButtonIndex()",
									conn.getString("getSelectedRadioButtonIndex"));
			connections.addElement(connection);

			getSelectedRadioButtonIndex.setValue(ConnectionDescriptor.CONNECTIONS, connections);
			md.addElement(getSelectedRadioButtonIndex);
		} catch (Exception e) { throw new Error("getSelectedRadioButtonIndex:: " + e.toString()); }

		MethodDescriptor[] rv = new MethodDescriptor[md.size()];
		md.copyInto(rv);

		return rv;
	}

	/**
	 * Returns descriptions of this bean's properties.
	 */
	public PropertyDescriptor[] getPropertyDescriptors() {
		ResourceBundle prop = ResourceBundle.getBundle("symantec.itools.resources.PropBundle");

		try{
		PropertyDescriptor selectedRadioButtonIndex = new PropertyDescriptor("selectedRadioButtonIndex", beanClass);
		selectedRadioButtonIndex.setBound(true);
		selectedRadioButtonIndex.setConstrained(true);
		selectedRadioButtonIndex.setDisplayName(prop.getString("selectedRadioButtonIndex"));

		PropertyDescriptor[] rv = {
			selectedRadioButtonIndex};
		return rv;
		} catch (IntrospectionException e) { throw new Error(e.toString()); }
	}

	private final static Class beanClass = RadioButtonGroupPanel.class;

	}	//  end of class RadioButtonGroupPanelBeanInfo