package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field for a social security number.
 * SocialSecurityNumber limits the type of text that can be entered in the text
 * box to a U.S. Social Security number (nine-digit number).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


public class SocialSecurityNumber
    extends SocialIDNumber
{
    /**
     * Create social security number text field.
     * This is a formatted text field
     * with the following format: 999/-99/-9999
     */
    public SocialSecurityNumber()
    {
        super(11);

        super.setMask("999/-99/-9999");
    }

    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the social security number mask.
     */
    public void setMask(String s)
    {
    }
}
