package symantec.itools.awt.util.edit;


/**
 *
 * Creates a formatted text field for a Zip code.
 * ZipCode limits the type of text that can be entered in the text
 * box to a U.S. five digit Zip Code (five-digit number).
 * Text formatting logic is applied to the user input.
 * If the text field already contains text, the user can select the default text
 * and delete or edit it.
 *
 *
 * @see symantec.itools.awt.FormattedTextField
 *
 * @version 1.0, Nov 26, 1996
 *
 * @author	Symantec
 *
 */


public class ZipCode
    extends AddressCode
{
    /**
     * Create Zip code text field.
     * This is a formatted text field
     * with the following format: 99999
     */
    public ZipCode()
    {
        super(5);

        super.setMask("99999");
    }
    /**
     * Takes no action.  Overrides setMask in FormattedTextField to prevent
     * alteration of the zip code mask.
     */
    public void setMask(String s)
    {
    }
}
